/*
	File:		ProcessMap.cpp
	Contains:	Implementation of the SOM class ProcessMap
	Written by:	PartMaker

	Change History (most recent first):

	<3>	4/18/95	JS		Updated to Developer Release 2
						Add ClonePartInfo.
						Inherited for InitPart, InitPartFromStorage.
						Fixed Externalize() inherited call.
						Removed inherited from Release().
						delete to ODDeleteObject().
	<2>	3/8/95	JS		Updated to b1c13/c14
	<1>	2/2/95	RA		first checked in
	<0>	PartMaker source by E. Soldan, T. elik, J. Alfke, R. Adkins, J. Schalk
*/

#ifndef _ALTPOINT_
#include <AltPoint.h>
#endif

#ifndef SOM_ODFrame_xh
#include <Frame.xh>
#endif

#ifndef SOM_ODFacet_xh
#include <Facet.xh>
#endif

#ifndef SOM_ODShape_xh
#include <Shape.xh>
#endif

#ifndef SOM_ODDraft_xh
#include <Draft.xh>
#endif

#ifndef SOM_ODStorageUnit_xh
#include <StorageU.xh>
#endif

#ifndef SOM_ODTransform_xh
#include <Trnsform.xh>
#endif

#ifndef SOM_ODWindow_xh
#include <Window.xh>
#endif

#ifndef __QUICKDRAW__
#include <Quickdraw.h>
#endif

#ifndef _CPPROCESSMAP_
#include "CPProcessMap.h"
#endif

#define SOM_Module_processmap_Source
#define VARIABLE_MACROS

#ifndef SOM_SomethingGood_ProcessMap_xih
#include <ProcessMap.xih>
#endif

#ifndef _ODUTILS_
#include <ODUtils.h>
#endif

//========================================================================================
// SomethingGood_ProcessMap
//========================================================================================

SOM_Scope void  SOMLINK SomethingGood_ProcessMapsomInit(SomethingGood_ProcessMap *somSelf)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	_fCPPart = kODNULL;
    SomethingGood_ProcessMap_parent_ODPart_somInit(somSelf);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapsomUninit(SomethingGood_ProcessMap *somSelf)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	if (_fCPPart)
		ODDeleteObject(_fCPPart);
    SomethingGood_ProcessMap_parent_ODPart_somUninit(somSelf);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapFulfillPromise(SomethingGood_ProcessMap *somSelf,
		Environment *ev,
		ODStorageUnitView* promiseSUView)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->FulfillPromise(ev,promiseSUView);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapDropCompleted(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODPart* destPart,
		ODDropResult dropResult)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->DropCompleted(ev,destPart,dropResult);
}

SOM_Scope ODDragResult  SOMLINK SomethingGood_ProcessMapDragEnter(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODDragItemIterator* dragInfo,
		ODFacet* facet,
		ODPoint* where)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    return (_fCPPart->DragEnter(ev,dragInfo,facet,where));
}

SOM_Scope ODDragResult  SOMLINK SomethingGood_ProcessMapDragWithin(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODDragItemIterator* dragInfo,
		ODFacet* facet,
		ODPoint* where)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    return (_fCPPart->DragWithin(ev,dragInfo,facet,where));
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapDragLeave(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFacet* facet,
		ODPoint* where)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->DragLeave(ev,facet,where);
}

SOM_Scope ODDropResult  SOMLINK SomethingGood_ProcessMapDrop(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODDragItemIterator* dropInfo,
		ODFacet* facet,
		ODPoint* where)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    return (_fCPPart->Drop(ev,dropInfo,facet,where));
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapContainingPartPropertiesChanged(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* frame,
		ODStorageUnit* propertyUnit)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->ContainingPartPropertiesChanged(ev,frame,propertyUnit);
}

SOM_Scope ODStorageUnit*  SOMLINK SomethingGood_ProcessMapGetContainingPartProperties(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    return (_fCPPart->GetContainingPartProperties(ev,frame));
}

SOM_Scope ODBoolean  SOMLINK SomethingGood_ProcessMapRevealFrame(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame,
		ODShape* revealShape)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    return (_fCPPart->RevealFrame(ev,embeddedFrame,revealShape));
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapEmbeddedFrameSpec(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame,
		ODObjectSpec* spec)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->EmbeddedFrameSpec(ev,embeddedFrame,spec);
}

SOM_Scope ODEmbeddedFramesIterator*  SOMLINK SomethingGood_ProcessMapCreateEmbeddedFramesIterator(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    return (_fCPPart->CreateEmbeddedFramesIterator(ev,frame));
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapDisplayFrameAdded(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
	SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->DisplayFrameAdded(ev,frame);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapDisplayFrameRemoved(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->DisplayFrameRemoved(ev,frame);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapDisplayFrameConnected(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->DisplayFrameConnected(ev,frame);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapDisplayFrameClosed(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->DisplayFrameClosed(ev,frame);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapAttachSourceFrame(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* frame,
		ODFrame* sourceFrame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->AttachSourceFrame(ev,frame,sourceFrame);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapFrameShapeChanged(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->FrameShapeChanged(ev,frame);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapViewTypeChanged(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->ViewTypeChanged(ev,frame);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapPresentationChanged(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->PresentationChanged(ev,frame);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapSequenceChanged(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->SequenceChanged(ev,frame);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapWritePartInfo(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODInfoType partInfo,
		ODStorageUnitView* storageUnitView)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->WritePartInfo(ev,partInfo,storageUnitView);
}

SOM_Scope ODInfoType  SOMLINK SomethingGood_ProcessMapReadPartInfo(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* frame,
		ODStorageUnitView* storageUnitView)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    return (_fCPPart->ReadPartInfo(ev,frame,storageUnitView));
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapClonePartInfo(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODDraftKey key,
		ODInfoType partInfo,
		ODStorageUnitView* storageUnitView,
		ODFrame* scopeFrame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->ClonePartInfo(ev,key,partInfo,storageUnitView,scopeFrame);
}

SOM_Scope ODID  SOMLINK SomethingGood_ProcessMapOpen(SomethingGood_ProcessMap *somSelf,
		Environment *ev,
		ODFrame* frame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	return (_fCPPart->Open(ev,frame));
}

SOM_Scope ODFrame*  SOMLINK SomethingGood_ProcessMapRequestEmbeddedFrame(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* containingFrame,
		ODFrame* baseFrame,
		ODShape* frameShape,
		ODPart* embedPart,
		ODTypeToken viewType,
		ODTypeToken presentation,
		ODBoolean isOverlaid)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	return (_fCPPart->RequestEmbeddedFrame(ev,containingFrame,baseFrame,frameShape,embedPart,viewType,presentation,isOverlaid));
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapRemoveEmbeddedFrame(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->RemoveEmbeddedFrame(ev,embeddedFrame);
}

SOM_Scope ODShape*  SOMLINK SomethingGood_ProcessMapRequestFrameShape(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame,
		ODShape* frameShape)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	return (_fCPPart->RequestFrameShape(ev,embeddedFrame,frameShape));
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapUsedShapeChanged(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->UsedShapeChanged(ev,embeddedFrame);
}

SOM_Scope ODShape*  SOMLINK SomethingGood_ProcessMapAdjustBorderShape(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFacet* embeddedFacet,
		ODShape* shape)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    return (_fCPPart->AdjustBorderShape(ev,embeddedFacet,shape));
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapFacetAdded(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFacet* facet)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->FacetAdded(ev,facet);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapFacetRemoved(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFacet* facet)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	_fCPPart->FacetRemoved(ev,facet);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapCanvasChanged(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFacet* facet)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	_fCPPart->CanvasChanged(ev,facet);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapGeometryChanged(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFacet* facet,
		ODBoolean clipShapeChanged,
		ODBoolean externalTransformChanged)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	_fCPPart->GeometryChanged(ev,facet,clipShapeChanged,externalTransformChanged);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapDraw(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFacet* facet,
		ODShape* invalidShape)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	_fCPPart->Draw(ev,facet,invalidShape);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapCanvasUpdated(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODCanvas* canvas)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	_fCPPart->CanvasUpdated(ev,canvas);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapHighlightChanged(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFacet* facet)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	_fCPPart->HighlightChanged(ev,facet);
}

SOM_Scope ODULong  SOMLINK SomethingGood_ProcessMapGetPrintResolution(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	return (_fCPPart->GetPrintResolution(ev,frame));
}

SOM_Scope ODLinkSource*  SOMLINK SomethingGood_ProcessMapCreateLink(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODByteArray* data)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	return (_fCPPart->CreateLink(ev,data));
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapLinkUpdated(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODLink* updatedLink,
		ODChangeID id)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	_fCPPart->LinkUpdated(ev,updatedLink,id);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapRevealLink(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODLinkSource* linkSource)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	_fCPPart->RevealLink(ev,linkSource);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapEmbeddedFrameChanged(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* frame,
		ODChangeID change)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	_fCPPart->EmbeddedFrameChanged(ev,frame,change);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapLinkStatusChanged(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	_fCPPart->LinkStatusChanged(ev,frame);
}

SOM_Scope ODBoolean  SOMLINK SomethingGood_ProcessMapBeginRelinquishFocus(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame,
		ODFrame* proposedFrame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	return (_fCPPart->BeginRelinquishFocus(ev,focus,ownerFrame,proposedFrame));
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapCommitRelinquishFocus(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame,
		ODFrame* proposedFrame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	_fCPPart->CommitRelinquishFocus(ev,focus,ownerFrame,proposedFrame);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapAbortRelinquishFocus(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame,
		ODFrame* proposedFrame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	_fCPPart->AbortRelinquishFocus(ev,focus,ownerFrame,proposedFrame);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapFocusAcquired(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	_fCPPart->FocusAcquired(ev,focus,ownerFrame);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapFocusLost(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	_fCPPart->FocusLost(ev,focus,ownerFrame);
}

SOM_Scope ODBoolean  SOMLINK SomethingGood_ProcessMapHasExtension(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODType extensionName)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	return (_fCPPart->HasExtension(ev,extensionName));
}

SOM_Scope ODExtension*  SOMLINK SomethingGood_ProcessMapGetExtension(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODType extensionName)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	return (_fCPPart->GetExtension(ev,extensionName));
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapReleaseExtension(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODExtension* extension)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	_fCPPart->ReleaseExtension(ev,extension);
}

SOM_Scope ODSize  SOMLINK SomethingGood_ProcessMapPurge(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODSize size)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    if  (_fCPPart)
		return (_fCPPart->Purge(ev,size));
	else
		return (SomethingGood_ProcessMap_parent_ODPart_Purge(somSelf,ev,size));
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapIncrementRefCount(SomethingGood_ProcessMap *somSelf, 
		Environment *ev)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    SomethingGood_ProcessMap_parent_ODPart_IncrementRefCount(somSelf,ev);

	_fCPPart->IncrementRefCount(ev);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapRelease(SomethingGood_ProcessMap *somSelf, 
		Environment *ev)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    SomethingGood_ProcessMap_parent_ODPart_Release(somSelf,ev);

    if (_fCPPart)
    	_fCPPart->Release(ev);
    	
	if (somSelf->GetRefCount(ev) == 0)
		somSelf->GetStorageUnit(ev)->GetDraft(ev)->ReleasePart(ev, somSelf);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapReleaseAll(SomethingGood_ProcessMap *somSelf, 
		Environment *ev)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->ReleaseAll(ev);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapExternalize(SomethingGood_ProcessMap *somSelf, 
		Environment *ev)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	SomethingGood_ProcessMap_parent_ODPart_Externalize(somSelf,ev);

	_fCPPart->Externalize(ev);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapCloneInto(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODDraftKey key,
		ODStorageUnit* storageUnit,
		ODFrame* initiatingFrame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	SomethingGood_ProcessMap_parent_ODPart_CloneInto(somSelf,ev,key,storageUnit,initiatingFrame);

    _fCPPart->CloneInto(ev,key,storageUnit,initiatingFrame);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapExternalizeKinds(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODTypeList* kindset)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->ExternalizeKinds(ev,kindset);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapChangeKind(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODType kind)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->ChangeKind(ev,kind);
}

SOM_Scope ODBoolean  SOMLINK SomethingGood_ProcessMapHandleEvent(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODEventData* event,
		ODFrame* frame,
		ODFacet* facet,
		ODEventInfo* eventInfo)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    return (_fCPPart->HandleEvent(ev,event,frame,facet,eventInfo));
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapAdjustMenus(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->AdjustMenus(ev,frame);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapUndoAction(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODActionData* actionState)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->UndoAction(ev,actionState);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapRedoAction(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODActionData* actionState)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->RedoAction(ev,actionState);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapDisposeActionState(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODActionData* actionState,
		ODDoneState doneState)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->DisposeActionState(ev,actionState,doneState);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapWriteActionState(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODActionData* actionState,
		ODStorageUnitView* storageUnitView)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    _fCPPart->WriteActionState(ev,actionState,storageUnitView);
}

SOM_Scope ODActionData  SOMLINK SomethingGood_ProcessMapReadActionState(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODStorageUnitView* storageUnitView)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
    return (_fCPPart->ReadActionState(ev,storageUnitView));
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapInitPart(SomethingGood_ProcessMap *somSelf,
		Environment *ev,
		ODStorageUnit* storageUnit, ODPart* partWrapper)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	if (somSelf->IsInitialized(ev))
		return;
	
	SomethingGood_ProcessMap_parent_ODPart_InitPart(somSelf,ev,storageUnit,partWrapper);
	
    _fCPPart = new CPProcessMap; // $$$$$ Check to see if it is nil
    _fCPPart->InitPart(ev,storageUnit, (ODPart*)partWrapper);
}

SOM_Scope void  SOMLINK SomethingGood_ProcessMapInitPartFromStorage(SomethingGood_ProcessMap *somSelf, 
		Environment *ev,
		ODStorageUnit* storageUnit, ODPart* partWrapper)
{
    SomethingGood_ProcessMapData *somThis = SomethingGood_ProcessMapGetData(somSelf);
	if (somSelf->IsInitialized(ev))
		return;

	SomethingGood_ProcessMap_parent_ODPart_InitPartFromStorage(somSelf,ev,storageUnit,partWrapper);
	
    _fCPPart = new CPProcessMap; // $$$$$ Check to see if it is nil
	_fCPPart->InitPartFromStorage(ev,storageUnit, (ODPart*)partWrapper);
}

