#	File:		ProcessMap.make
#	Contains:	Makefile for ProcessMap part editor for 68K
#
#	Change History (most recent first):
#
#	<2>	4/20/95	JS		Updated for Developer Release 2.
#	<1>	2/2/95	RA		First checked in.
#	<0>	PartMaker source by E. Soldan, T. elik, J. Alfke, J. Schalk

#---------------------------------------------------------------------------	
# PROJECT VARIABLES
#---------------------------------------------------------------------------	

TargetName 			= ProcessMap
TargetNameILink 	= {TargetName}-ILink

ProjectDir 			= :
SourceDir 			= {ProjectDir}$Sources:
ObjectsDir 			= {ProjectDir}$Objects:
TargetDir 			= {ProjectDir}
HeaderDir			= {ProjectDir}$Headers:
ResourceDir			= {ProjectDir}$Resources:
UtilitiesDir		= {ProjectDir}$Utilities:
LocalIDLDir			= {ProjectDir}$SOM:

ODCppIntfDir		= {OpenDocDir}Interfaces:CPlusPlus:
ODCIntfDir			= {OpenDocDir}Interfaces:C:
ODHandMadeIntfDir	= {OpenDocDir}Interfaces:HandMade:
ODIDLIntfDir		= {OpenDocDir}Interfaces:IDL:
ODRezIntfDir		= {OpenDocDir}Interfaces:Rez:
ODUtilIntfDir		= {OpenDocDir}OpenDoc Utilities:Interfaces:
ODUtilImplDir		= {OpenDocDir}OpenDoc Utilities:Implementation:

ODStubLibrariesDir	= {OpenDocDir}Libraries:PEF:

#---------------------------------------------------------------------------	
# DIRECTORY DEPENDENCIES
#---------------------------------------------------------------------------	

"{ObjectsDir}" 		 "{ProjectDir}"
"{ObjectsDir}" 		 "{SourceDir}"
"{ObjectsDir}" 		 "{UtilitiesDir}"
"{ObjectsDir}" 		 "{ODUtilIntfDir}"
"{ObjectsDir}" 		 "{ODUtilImplDir}"
"{ObjectsDir}" 		 "{LocalIDLDir}"

#---------------------------------------------------------------------------	
# LIBRARIES
#---------------------------------------------------------------------------	

NuRTLibraries = "{SharedLibraries}"StdCLib			
				"{SharedLibraries}"SOM 				
				"{SharedLibraries}"InterfaceLib		
				"{CFM68KLibraries}"NuCPlusLib.o		
				"{CFM68KLibraries}"NuMacRuntime.o	
				"{CFM68KLibraries}"NuRTLib.o		
				"{CFM68KLibraries}"NuMathLib.o

ShLibPreLibraries = 

ShLibPostLibraries = {NuRTLibraries}

#---------------------------------------------------------------------------	
# COMPILERS, TOOLS
#---------------------------------------------------------------------------	

CPlus 						= SCpp
SymOption 					= -sym full
MacsbugOption 				= -mbg full

GOptions 					= -d _PLATFORM_MACINTOSH_=1	
							  -d ODDebug=0 
							  -model cfmseg 
							  {SymOption} 
							  {MacsbugOption} 
							  -b3 
							  -O none

COptions 					= {GOptions} -dialect ansic

CPlusOptions 				= {GOptions} -dialect cplus

AsmOptions					= -model cfmseg

ILinkOptions 				= -model cfmseg	
							  -sym on 
							  -mf 
							  -xm s

RezOptions 					= -c RSED -t rsrc

#---------------------------------------------------------------------------	
# FILE LIST VARIABLES
#---------------------------------------------------------------------------	

ProcessMapOBJECTS = 
	"{ObjectsDir}CPProcessMap.cpp.o"			
	"{ObjectsDir}CPProcessMap.Bind.cpp.o"	
	"{ObjectsDir}CPProcessMap.DD.cpp.o"		
	"{ObjectsDir}CPProcessMap.Embed.cpp.o"	
	"{ObjectsDir}CPProcessMap.Event.cpp.o"	
	"{ObjectsDir}CPProcessMap.Ext.cpp.o"		
	"{ObjectsDir}CPProcessMap.Focus.cpp.o"	
	"{ObjectsDir}CPProcessMap.Frame.cpp.o"	
	"{ObjectsDir}CPProcessMap.Image.cpp.o"	
	"{ObjectsDir}CPProcessMap.InEx.cpp.o"	
	"{ObjectsDir}CPProcessMap.Link.cpp.o"	
	"{ObjectsDir}CPProcessMap.Undo.cpp.o"	
	"{ObjectsDir}FrameList.cpp.o"			
	"{ObjectsDir}PartUtils.cpp.o"			
	"{ObjectsDir}ProcessMap.cpp.o"			
	"{ObjectsDir}ProcessMapInit.cpp.o"		
	"{ObjectsDir}AltPoint.cpp.o"			
	"{ObjectsDir}AltPoly.cpp.o"				
	"{ObjectsDir}Except.cpp.o"				
	"{ObjectsDir}FlipEnd.cpp.o" 			
	"{ObjectsDir}FocusLib.cpp.o"			
	"{ObjectsDir}InfoUtil.cpp.o"			
	"{ObjectsDir}ISOStr.cpp.o" 				
	"{ObjectsDir}IText.cpp.o"				
	"{ObjectsDir}ODDebug.cpp.o"				
	"{ObjectsDir}ODMemory.cpp.o"			
	"{ObjectsDir}ODNew.cpp.o"				
	"{ObjectsDir}ODNewObj.cpp.o"			
	"{ObjectsDir}ODUtils.cpp.o"				
	"{ObjectsDir}NmSpcUtl.cpp.o" 			
	"{ObjectsDir}PasclStr.cpp.o"			
	"{ObjectsDir}POUtils.cpp.o"				
	"{ObjectsDir}StdTypIO.cpp.o"			
	"{ObjectsDir}StorUtil.cpp.o"			
	"{ObjectsDir}UseRsrcM.cpp.o"			
	"{ObjectsDir}WinUtils.cpp.o" 			
	
	
# List of Utilities unused. Add as required

UtilitiesOBJECTS = 
	"{ObjectsDir}BArray.cpp.o" 				
	"{ObjectsDir}DictList.cpp.o" 			
	"{ObjectsDir}DlogUtil.cpp.o" 			
	"{ObjectsDir}EditrSet.cpp.o" 			
	"{ObjectsDir}HshTbl.c.o" 				
	"{ObjectsDir}LineOps.cpp.o" 			
	"{ObjectsDir}List.cpp.o" 				
	"{ObjectsDir}Node.cpp.o" 				
	"{ObjectsDir}ODMathM.a.o" 				
	"{ObjectsDir}ODMathM.cpp.o" 			
	"{ObjectsDir}OpenHash.cpp.o" 			
	"{ObjectsDir}OrdColl.cpp.o" 			
	"{ObjectsDir}PlfmFile.cpp.o" 			
	"{ObjectsDir}PriortyQ.cpp.o" 			
	"{ObjectsDir}RegisterFileLibs.c.o" 		
	"{ObjectsDir}SIHelper.cpp.o" 			
	"{ObjectsDir}SIHshTbl.cpp.o" 			
	"{ObjectsDir}StdIFmIO.cpp.o" 			
	"{ObjectsDir}StrHshTb.cpp.o" 			
	"{ObjectsDir}TransUtl.cpp.o" 			
	
			
#---------------------------------------------------------------------------	
# ROOT TARGET
#---------------------------------------------------------------------------	

BUILDREZ  
	"{ResourceDir}"ProcessMap.68K.rsrc

BUILDILINK  
	"{ResourceDir}"ProcessMap.68K.rsrc		
	"{TargetDir}{TargetNameILink}"

BUILDCPPIDL  
	"{LocalIDLDir}"ProcessMap.xih			
	"{LocalIDLDir}"ProcessMap.xh				
	"{LocalIDLDir}"ProcessMap.cpp


#---------------------------------------------------------------------------	
# BUILD LIBRARIES
#---------------------------------------------------------------------------	

{TargetDir}{TargetNameILink}   {ProcessMapOBJECTS} 
	"{ResourceDir}"ProcessMap.68K.rsrc
	Echo Linking: {TargetNameILink}
	Unset ExportObjects
	ILink	
		{ILinkOptions}										
		-init PROCESSMAPCFMINIT								
		-m ProcessMapSOMInit									
		{ShLibPreLibraries}									
		{ProcessMapOBJECTS}									
		"{ODStubLibrariesDir}Memory Manager.stub" 			
		"{ODStubLibrariesDir}OpenDoc Core.stub" 			
		"{ODStubLibrariesDir}OpenDoc Storage.stub" 			
		"{ODStubLibrariesDir}OpenDoc OSL.stub" 				
		"{ODStubLibrariesDir}OpenDoc Messaging.stub" 		
		"{ODStubLibrariesDir}OpenDoc Imaging.stub" 			
		"{ODStubLibrariesDir}OpenDoc Layout.stub"			
		"{ODStubLibrariesDir}OpenDoc User Interface.stub"	
		{ShLibPostLibraries}								
		-o "{ObjectsDir}{TargetNameILink}".seg
	If !{Status}
		ILinkToSym "{ObjectsDir}{TargetNameILink}".seg.NJ	
			-o "{TargetDir}{TargetNameILink}".SYM
		MakeFlat "{ObjectsDir}{TargetNameILink}".seg		
			-o "{TargetDir}{TargetNameILink}"
		SetFile -c cfmg "{TargetDir}{TargetNameILink}"
		SetFile -m . {Targ}
	End

#---------------------------------------------------------------------------	
# REZ STEPS
#---------------------------------------------------------------------------	

"{ResourceDir}"ProcessMap.68K.rsrc 	"{ResourceDir}"ProcessMap.r 
								"{ResourceDir}ProcessMap.ResEdit" 
								"{HeaderDir}ProcessMapDef.h"
	Rez -d _68KBUILD_ {RezOptions} -i "{ODCppIntfDir}" -i "{ODRezIntfDir}" 
		"{ResourceDir}"ProcessMap.r 
		 -a -o "{ResourceDir}"ProcessMap.68K.rsrc

"{TargetDir}{TargetNameILink}"   "{ResourceDir}"ProcessMap.68K.rsrc
	Echo "include "{ResourceDir}ProcessMap.68K.rsrc";" | Rez -a -o "{TargetDir}{TargetNameILink}"
	Echo "delete 'ckid';"  | Rez -a -o "{TargetDir}{TargetNameILink}"

#---------------------------------------------------------------------------	
# DEPENDENCIES
#---------------------------------------------------------------------------	

# IDL

"{LocalIDLDir}"ProcessMap.cpp  			
	"{LocalIDLDir}"ProcessMap.idl

"{LocalIDLDir}"ProcessMap.xih  			
	"{LocalIDLDir}"ProcessMap.xh			
	"{LocalIDLDir}"ProcessMap.idl

"{LocalIDLDir}"ProcessMap.xh  			
	"{LocalIDLDir}"ProcessMap.idl

# SOURCE/OBJECT CODE (SOM wrapper object)

"{ObjectsDir}"ProcessMap.cpp.o  		
	"{LocalIDLDir}"ProcessMap.cpp		
	"{LocalIDLDir}"ProcessMap.xih

# SOURCE/OBJECT CODE (C++ helper object)

"{ObjectsDir}"ProcessMapInit.cpp.o  	
	"{LocalIDLDir}"ProcessMapInit.cpp	
	"{LocalIDLDir}"ProcessMap.xh

"{ObjectsDir}"CPProcessMap.cpp.o  		
	"{ProjectDir}"CPProcessMap.cpp		
	"{HeaderDir}"CPProcessMap.h			
	"{HeaderDir}"ProcessMapDef.h

"{ObjectsDir}"CPProcessMap.Bind.cpp.o  	
	"{SourceDir}"CPProcessMap.Bind.cpp	
	"{HeaderDir}"CPProcessMap.h			
	"{HeaderDir}"ProcessMapDef.h

"{ObjectsDir}"CPProcessMap.DD.cpp.o  	
	"{SourceDir}"CPProcessMap.DD.cpp		
	"{HeaderDir}"CPProcessMap.h			
	"{HeaderDir}"ProcessMapDef.h

"{ObjectsDir}"CPProcessMap.Embed.cpp.o  
	"{SourceDir}"CPProcessMap.Embed.cpp	
	"{HeaderDir}"CPProcessMap.h			
	"{HeaderDir}"ProcessMapDef.h

"{ObjectsDir}"CPProcessMap.Event.cpp.o  
	"{SourceDir}"CPProcessMap.Event.cpp	
	"{HeaderDir}"CPProcessMap.h			
	"{HeaderDir}"ProcessMapDef.h

"{ObjectsDir}"CPProcessMap.Ext.cpp.o  	
	"{SourceDir}"CPProcessMap.Ext.cpp	
	"{HeaderDir}"CPProcessMap.h			
	"{HeaderDir}"ProcessMapDef.h

"{ObjectsDir}"CPProcessMap.Focus.cpp.o  
	"{SourceDir}"CPProcessMap.Focus.cpp	
	"{HeaderDir}"CPProcessMap.h			
	"{HeaderDir}"ProcessMapDef.h

"{ObjectsDir}"CPProcessMap.Frame.cpp.o  
	"{SourceDir}"CPProcessMap.Frame.cpp	
	"{HeaderDir}"CPProcessMap.h			
	"{HeaderDir}"ProcessMapDef.h

"{ObjectsDir}"CPProcessMap.Image.cpp.o  
	"{SourceDir}"CPProcessMap.Image.cpp	
	"{HeaderDir}"CPProcessMap.h			
	"{HeaderDir}"ProcessMapDef.h

"{ObjectsDir}"CPProcessMap.InEx.cpp.o  	
	"{SourceDir}"CPProcessMap.InEx.cpp	
	"{HeaderDir}"CPProcessMap.h			
	"{HeaderDir}"ProcessMapDef.h

"{ObjectsDir}"CPProcessMap.Link.cpp.o  	
	"{SourceDir}"CPProcessMap.Link.cpp	
	"{HeaderDir}"CPProcessMap.h			
	"{HeaderDir}"ProcessMapDef.h

"{ObjectsDir}"CPProcessMap.Undo.cpp.o  	
	"{SourceDir}"CPProcessMap.Undo.cpp	
	"{HeaderDir}"CPProcessMap.h			
	"{HeaderDir}"ProcessMapDef.h

# UTILS

"{ObjectsDir}"FrameList.cpp.o  		
	"{UtilitiesDir}"FrameList.cpp		
	"{UtilitiesDir}"FrameList.h			
	"{HeaderDir}"CPProcessMap.h

"{ObjectsDir}"PartUtils.cpp.o  		
	"{UtilitiesDir}"PartUtils.cpp		
	"{UtilitiesDir}"PartUtils.h			
	"{HeaderDir}"CPProcessMap.h

# OPENDOC UTILS (MORE THAN REQUIRED)

"{ObjectsDir}"AltPoint.cpp.o	  		
	"{ODUtilImplDir}"AltPoint.cpp 		
	"{ODUtilIntfDir}"AltPoint.h

"{ObjectsDir}"AltPoly.cpp.o	  			
	"{ODUtilImplDir}"AltPoly.cpp 		
	"{ODUtilIntfDir}"AltPoly.h

"{ObjectsDir}"BArray.cpp.o	  			
	"{ODUtilImplDir}"BArray.cpp 		
	"{ODUtilIntfDir}"BArray.h

"{ObjectsDir}"DictList.cpp.o	  		
	"{ODUtilImplDir}"DictList.cpp 		
	"{ODUtilIntfDir}"DictList.h

"{ObjectsDir}"DlogUtil.cpp.o	  		
	"{ODUtilImplDir}"DlogUtil.cpp 		
	"{ODUtilIntfDir}"DlogUtil.h

"{ObjectsDir}"EditrSet.cpp.o	  		
	"{ODUtilImplDir}"EditrSet.cpp 		
	"{ODUtilIntfDir}"EditrSet.h

"{ObjectsDir}"Except.cpp.o	  			
	"{ODUtilImplDir}"Except.cpp 		
	"{ODUtilIntfDir}"Except.h

"{ObjectsDir}"FlipEnd.cpp.o	  			
	"{ODUtilImplDir}"FlipEnd.cpp 		
	"{ODUtilIntfDir}"FlipEnd.h

"{ObjectsDir}"FocusLib.cpp.o	  		
	"{ODUtilImplDir}"FocusLib.cpp 		
	"{ODUtilIntfDir}"FocusLib.h

"{ObjectsDir}"HshTbl.c.cpp.o	  		
	"{ODUtilImplDir}"HshTbl.c.cpp 		
	"{ODUtilIntfDir}"HshTbl.c.h

"{ObjectsDir}"InfoUtil.cpp.o	  		
	"{ODUtilImplDir}"InfoUtil.cpp 		
	"{ODUtilIntfDir}"InfoUtil.h

"{ObjectsDir}"ISOStr.cpp.o	  			
	"{ODUtilImplDir}"ISOStr.cpp 		
	"{ODUtilIntfDir}"ISOStr.h

"{ObjectsDir}"IText.cpp.o	  			
	"{ODUtilImplDir}"IText.cpp 			
	"{ODUtilIntfDir}"IText.h

"{ObjectsDir}"LineOps.cpp.o	  			
	"{ODUtilImplDir}"LineOps.cpp 		
	"{ODUtilIntfDir}"LineOps.h

"{ObjectsDir}"List.cpp.o	  			
	"{ODUtilImplDir}"List.cpp 			
	"{ODUtilIntfDir}"List.h

"{ObjectsDir}"Node.cpp.o	  			
	"{ODUtilImplDir}"Node.cpp 			
	"{ODUtilIntfDir}"Node.h

"{ObjectsDir}"ODDebug.cpp.o	  			
	"{ODUtilImplDir}"ODDebug.cpp 		
	"{ODUtilIntfDir}"ODDebug.h

"{ObjectsDir}"ODMathM.cpp.o	  			
	"{ODUtilImplDir}"ODMathM.cpp 		
	"{ODUtilIntfDir}"ODMathM.h

"{ObjectsDir}"ODMemory.cpp.o	  		
	"{ODUtilImplDir}"ODMemory.cpp 		
	"{ODUtilIntfDir}"ODMemory.h

"{ObjectsDir}"ODNew.cpp.o	  			
	"{ODUtilImplDir}"ODNew.cpp 			
	"{ODUtilIntfDir}"ODNew.h

"{ObjectsDir}"ODNewObj.cpp.o	  		
	"{ODUtilImplDir}"ODNewObj.cpp 		
	"{ODUtilIntfDir}"ODNewObj.h

"{ObjectsDir}"ODUtils.cpp.o	  			
	"{ODUtilImplDir}"ODUtils.cpp 		
	"{ODUtilIntfDir}"ODUtils.h

"{ObjectsDir}"OpenHash.cpp.o	  		
	"{ODUtilImplDir}"OpenHash.cpp 		
	"{ODUtilIntfDir}"OpenHash.h

"{ObjectsDir}"OrdColl.cpp.o	  			
	"{ODUtilImplDir}"OrdColl.cpp 		
	"{ODUtilIntfDir}"OrdColl.h

"{ObjectsDir}"PasclStr.cpp.o	  		
	"{ODUtilImplDir}"PasclStr.cpp 		
	"{ODUtilIntfDir}"PasclStr.h

"{ObjectsDir}"PlfmFile.cpp.o	  		
	"{ODUtilImplDir}"PlfmFile.cpp 		
	"{ODUtilIntfDir}"PlfmFile.h

"{ObjectsDir}"POUtils.cpp.o	  			
	"{ODUtilImplDir}"POUtils.cpp 		
	"{ODUtilIntfDir}"POUtils.h

"{ObjectsDir}"PriortyQ.cpp.o	  		
	"{ODUtilImplDir}"PriortyQ.cpp 		
	"{ODUtilIntfDir}"PriortyQ.h

"{ObjectsDir}"SemtIntf.cpp.o	  		
	"{ODUtilImplDir}"SemtIntf.cpp 		
	"{ODUtilIntfDir}"SemtIntf.h

"{ObjectsDir}"SIHelper.cpp.o	  		
	"{ODUtilImplDir}"SIHelper.cpp 		
	"{ODUtilIntfDir}"SIHelper.h

"{ObjectsDir}"SIHshTbl.cpp.o	  		
	"{ODUtilImplDir}"SIHshTbl.cpp 		
	"{ODUtilIntfDir}"SIHshTbl.h

"{ObjectsDir}"StdIFmIO.cpp.o	  		
	"{ODUtilImplDir}"StdIFmIO.cpp 		
	"{ODUtilIntfDir}"StdIFmIO.h

"{ObjectsDir}"StdTypIO.cpp.o	  		
	"{ODUtilImplDir}"StdTypIO.cpp 		
	"{ODUtilIntfDir}"StdTypIO.h

"{ObjectsDir}"StorUtil.cpp.o	  		
	"{ODUtilImplDir}"StorUtil.cpp 		
	"{ODUtilIntfDir}"StorUtil.h

"{ObjectsDir}"StrHshTb.cpp.o	  		
	"{ODUtilImplDir}"StrHshTb.cpp 		
	"{ODUtilIntfDir}"StrHshTb.h

"{ObjectsDir}"TransUtl.cpp.o	  		
	"{ODUtilImplDir}"TransUtl.cpp 		
	"{ODUtilIntfDir}"TransUtl.h

"{ObjectsDir}"UseRsrcM.cpp.o	  		
	"{ODUtilImplDir}"UseRsrcM.cpp 		
	"{ODUtilIntfDir}"UseRsrcM.h

"{ObjectsDir}"WinUtils.cpp.o	  		
	"{ODUtilImplDir}"WinUtils.cpp 		
	"{ODUtilIntfDir}"WinUtils.h

#---------------------------------------------------------------------------	
# DEFAULT RULES
#---------------------------------------------------------------------------	

.cpp.o		.cpp
	{CPlus} {CPlusOptions} {depDir}{default}.cpp -o {targDir}{default}.cpp.o 
	-i {depDir} -i "{CIncludes}" -i "{ODCppIntfDir}" -i "{ODHandMadeIntfDir}" 
	-i "{ODUtilIntfDir}" -i "{HeaderDir}" -i "{UtilitiesDir}"

.c.o		.c
	{C} {depDir}{default}.c -o {targDir}{default}.c.o {COptions} 
	-i {depDir} -i "{CIncludes}" -i "{ODCIntfDir}" -i "{ODHandMadeIntfDir}" 
	-i "{ODUtilIntfDir}"  -i "{HeaderDir}" -i "{UtilitiesDir}"

.a.o		.a
	{Asm} {depDir}{default}.a -o {targDir}{default}.a.o {AsmOptions} 
	-i {depDir} -i "{CIncludes}" -i "{ODCIntfDir}" -i "{ODHandMadeIntfDir}" 
	-i "{ODUtilIntfDir}"  -i "{HeaderDir}" -i "{UtilitiesDir}"

.xih  .idl
	somc -other "-S 100000" -p -e xih {depDir}{default}.idl 
		-o {depDir} -I {depDir} -i "{ODIDLIntfDir}"
	SetFile -m . {targDir}{default}.xih

.xh  .idl
	somc -other "-S 100000" -p -e xh {depDir}{default}.idl 
		-o {depDir} -I {depDir} -i "{ODIDLIntfDir}"
	SetFile -m . {targDir}{default}.xh

.cpp  .idl
	somc -other "-S 100000" -m cpluscpp -p -e xc {depDir}{default}.idl 
		-o {depDir} -I {depDir} -i "{ODIDLIntfDir}"
	SetFile -m . {targDir}{default}.cpp

.ih  .idl
	somc -other "-S 100000" -p -e ih {depDir}{default}.idl 
		-o {depDir} -I {depDir} -i "{ODIDLIntfDir}"
	SetFile -m . {targDir}{default}.ih

.h  .idl
	somc -other "-S 100000" -p -e h {depDir}{default}.idl 
		-o {depDir} -I {depDir} -i "{ODIDLIntfDir}"
	SetFile -m . {targDir}{default}.h

.c  .idl
	somc -other "-S 100000" -p -e c {depDir}{default}.idl 
		-o {depDir} -I {depDir} -i "{ODIDLIntfDir}"
	SetFile -m . {targDir}{default}.c

.exp  .idl
	somc -other "-S 100000" -e exp {depDir}{default}.idl 
		-o {depDir} -I {depDir} -i "{ODIDLIntfDir}"
	SetFile -m . {targDir}{default}.exp
